function PSNR = psnr(im, ref)
    % PSNR computation for two images (RGB or gayscale). The image intensities
    % are assumed to be in the range 0-255.
    d = double(im(:))-double(ref(:));
    d = d.^2;
    PSNR = 20*log10(255/sqrt(sum(d)/length(d)));
end